/********************************************************************************************

 Author : John Carlo C. Naoz
 Program Name : Simple File Manipulation In C++
 Date : November 11, 2016

 Features: 1 - Save to a file 
           2 - View file content  
           3 - Obtain file size  
           4 - File Detail      
           5 - Clear the file     
           6 - Delete the file    
           7 - Color Changing after each selection
					
********************************************************************************************/
#include <iostream>
#include <stdlib.h>
#include <string>
#include <fstream>
#include <ctime>
#include <sys/types.h>
#include <sys/stat.h>
#include <cerrno>
using namespace std;

int main () {
	
	/* Display the title of the program */

	system("color 02");
	cout<<"\n\n";
	cout<<"  [][][] [][][] []     [][][]\n";
	cout<<"  []       []   []     []\n";
	cout<<"  [][]     []   []     [][]\n";
	cout<<"  []       []   []     [] \n";
	cout<<"  []     [][][] [][][] [][][]\n\n";
	cout<<"  []    []   []   []]  [] [] [][][] []  [] []      []   [][][] [] [][][] []]  []\n";
	cout<<"  []}[]{[] []  [] [][] [] [] []  [] []  [] []    []  []   []   [] []  [] [][] []\n";
	cout<<"  [] [] [] [][][] [] [][] [] [][][] []  [] []    [][][]   []   [] []  [] [] [][]\n";
	cout<<"  []    [] []  [] []  []] [] []     []  [] []    []  []   []   [] []  [] []  []]\n";
	cout<<"  []    [] []  [] []   [] [] []     [][][] [][[] []  []   []   [] [][][] []   []\n\n";

	cout<<"\n\n\t\t      Developed by: MANFRED RICHTHOFEN \1 \2 \3 \4 \5 \6 \7\n\n\n\n\n\n\n";
	system("pause");
	system("cls");
	
		/* Display the MENU */
		
     string option;
     system("color 05");
	 menu:
	 cout << endl;
	 cout << "         =====================================" << endl;
     cout << "         ||     WELCOME TO THE PROGRAM      ||" << endl;
     cout << "         =====================================" << endl;
     cout << "         || 1 - Save to a file              ||" << endl;
     cout << "         || 2 - View file content           ||" << endl;
     cout << "         || 3 - Obtain file size            ||" << endl;
     cout << "         || 4 - File Detail                 ||" << endl;
     cout << "         || 5 - Clear the file              ||" << endl;
     cout << "         || 6 - Delete the file             ||" << endl;
     cout << "         || 7 - Exit the Program            ||" << endl;
     cout << "         =====================================" << endl;
     cout << "\n          Enter Your Choice:	";
     getline(cin,option);
     
     if (option == "1") {
     	
       system("cls");
       system("color 06");
       string textToSave;
       cout << "        ========================================" << endl;
       cout << "        || ENTER THE STRING YOU WANT TO SAVE  ||\n" ;	//save a string
       cout << "        ========================================\n\n" << endl;
       cout << "        HERE: ";
       getline(cin,textToSave);
       ofstream saveFile ("file.txt");
       saveFile << textToSave;
       cout << "" << endl<< endl<< endl<< endl<< endl<< endl; 
       saveFile.close(); 
       
       system("pause");
 		system("cls");
 					
		goto menu;
     }
     
     if(option == "2") {
     	  system("color 03");
     	  system("cls");
          ifstream loadFile;
          loadFile.open ("file.txt", ifstream::in);					//View file content 
          cout << "        ========================================" << endl;
          cout << "        ||    THE FILE CONTAINS THE STRING    ||\n" ;	
          cout << "        ========================================\n\n" << endl;
          cout << "        ";
          while (loadFile.good()){
               cout << (char) loadFile.get();
          }
          cout << "" << endl<< endl<< endl<< endl<< endl<< endl; 
    	  loadFile.close();
    	  
    	  system("pause");
 		system("cls");
 					
		goto menu;
     }
     
      if (option == "3") {
     	
     	system("cls");
     	system("color f");
        streampos begin,end;
  		ifstream myfile ("file.txt", ios::binary);							//Obtain file size
 		begin = myfile.tellg();
  		myfile.seekg (0, ios::end);
  		end = myfile.tellg();
 		myfile.close();
 		cout << "        ========================================" << endl;
        cout << "        ||           THE FILE SIZE IS         ||\n" ;
        cout << "        ========================================\n\n" << endl;
        cout << "\n\n\n\t\t\t";
  		cout << (end-begin) << " bytes.\n";
		cout << "" << endl<< endl<< endl<< endl<< endl;    
  		
  		system("pause");
 		system("cls");
 					
		goto menu;
     }
     
      if (option == "4") {
     	
     	system("cls");
        int argc; 
		char** argv ;
   		struct stat fileInfo;

   		if (stat("file.txt", &fileInfo) != 0) {  // Use stat( ) to get the info
   		  system("color 04");
   		  cout << "\n\n\n\n\n\n\n";
	   	  cout << "        ==================" << endl;
          cout << "        ||     ERROR    ||\n" ;	
          cout << "        ==================\n\n" << endl;
          cout << "        ";
	      std::cerr << strerror(errno) << '\n';
	      cout << "\n\n\n\n\n\n\n";
	      return 0;
   		}

		system("color d");
		cout << "     =====================================================" << endl;
   		cout << "     || Size               : " << fileInfo.st_size <<"  bytes"<<'\n';     // Size in bytes
   		cout << "     || Drive letter saved : " << (char)(fileInfo.st_dev + 'A') << '\n';  // Device number
   		cout << "     || Created            : " << std::ctime(&fileInfo.st_ctime);         // Creation time
   		cout << "     || Modified           : " << std::ctime(&fileInfo.st_mtime);         // Last mod time
   		cout << "     =====================================================" << endl;
  		cout << "\n\n\n";
  		system("pause");
 		system("cls");
 					
		goto menu;
     }
     
     if (option == "5") {
     	system("color e");
     	system("cls");
 		std::ofstream ofs ("file.txt", std::ios::out | std::ios::trunc); // clear contents of the file
		cout << "\n\n\n\n"; 
 		cout << "        ========================================" << endl;
        cout << "        ||     FILE SUCCESSFULLY CLEARED      ||\n" ;	
        cout << "        ========================================\n\n" << endl;
 		
 		system("pause");
 		system("cls");
 					
		goto menu;
     }
     
     if (option == "6") {
     	system("color 04");
     	system("cls");
    	std::remove("file.txt"); 									//Delete the file 
    	cout << "\n\n\n\n"; 
 		cout << "        ========================================" << endl;
        cout << "        ||     FILE SUCCESSFULLY REMOVED      ||\n" ;	
        cout << "        ========================================\n\n" << endl;
 		
 		system("pause");
 		system("cls");
 					
		goto menu;
     }
     
     if (option == "7") {
     	system("color 02");
     	system("cls");
 			cout<<"\n\n";
			cout<<"[][][] [][][] [][][] [][][] [][][]    []    []    []\n";	
			cout<<"[]  [] []  [] []  [] []     []  []  []  []  [][][][]\n";
			cout<<"[][][] [][][] []  [] [] []  [][][] [][][][] [] [] []\n";
			cout<<"[]     [] []  []  [] []  [] [] []  []    [] []    []\n";
			cout<<"[]     []  [] [][][] [][][] []  [] []    [] []    []\n\n";
			cout<<"[][][] [][][]     [][][] []     [][][] [][][] [][][] []   [] [][][]\n";	
			cout<<"  []   []         []  [] []     []  [] []       []   []]  [] []\n";
			cout<<"  []   [][][]     []     []     []  [] [][][]   []   [][] [] [] []\n";
			cout<<"  []       []     []  [] []     []  []     []   []   [] [][] []  []\n";
			cout<<"[][][] [][][]     [][][] [][][] [][][] [][][] [][][] []  [[] [][][]\n\n";
			cout<<"[][][]  []     [] [][][]   [] [] []\n";	
			cout<<"[]   []  []  []   []       [] [] []\n";
			cout<<"[]  []     []     [][][]   [] [] []\n";
			cout<<"[]   []    []     []\n";
			cout<<"[][][]     []     [][][]   [] [] []\n\n";
 		
 		system("pause");
 		return 0;
     }
     
     else;
     system("cls");
			cout<<"\n\n\n\n\n\n";
			cout<<"\t\t\t[][][] [][][] [][][] [][][] [][][]\n";
			cout<<"\t\t\t[]     []  [] []  [] []  [] []  []\n";
			cout<<"\t\t\t[][][] [][][] [][][] []  [] [][][]\n";
			cout<<"\t\t\t[]     [] []  [] []  []  [] [] []\n";
			cout<<"\t\t\t[][][] []  [] []  [] [][][] []  []\n\n";
				
			cout<<"\t\t\tPlease input a valid number.\n";
			cout<<"\t\t\tPress any key to go back to the Menu.\n\n\n\n\n\n\n";
				
			system("pause");
			system("cls");
			goto menu;
			
     
     system("pause");
	 return 0;
}
